diff -ruN apt-0.7.13/etc/cron.daily/apt apt-0.7.13-patched/etc/cron.daily/apt
--- apt-0.7.13/etc/cron.daily/apt	2008-05-02 17:14:22.000000000 +0200
+++ apt-0.7.13-patched/etc/cron.daily/apt	2008-05-25 00:34:38.000000000 +0200
@@ -192,19 +192,27 @@
     fi
 fi
 
-# check if we can lock the cache and if the cache is clean
-# There's a reasonable chance that someone is already running an apt
-# frontend that has locked the cache, so exit quietly if it is locked.
-if ! apt-get check -q -q 2>/dev/null; then
-    exit 0
-fi
+# if needed...
+if [ ! $UpdateInterval -eq 0 ] ||
+   [ ! $DownloadUpgradeableInterval -eq 0 ] ||
+   [ ! $UnattendedUpgradeInterval -eq 0 ] ||
+   [ ! $AutocleanInterval -eq 0 ]; then
+
+    # wait random amount of time, to avoid massive mirror usage from
+    # too many systems...
+    random_sleep
+
+    # check if we can lock the cache and if the cache is clean
+    if ! apt-get check -q -q 2>/dev/null; then
+        # wait random amount of time before retrying
+        random_sleep
+        # check again
+        if ! apt-get check -q -q 2>/dev/null; then
+            echo "$0: could not lock the APT cache"
+            exit 1
+        fi
+    fi
 
-# sleep random amount of time
-random_sleep
-
-# check again if we can access the cache
-if ! apt-get check -q -q 2>/dev/null; then
-    exit 1
 fi
 
 UPDATE_STAMP=/var/lib/apt/periodic/update-stamp
